#ifndef __IMMS_H
#define __IMMS_H

#include <string>
#include <fstream>
#include <id3/tag.h>

#define FIRST_SKIP_RATE -8
#define CONS_SKIP_RATE -4
#define FIRST_NON_SKIP_RATE 6
#define JUMPED_FROM -1
#define JUMPED_TO 4
#define JUMPED_TO_FIN 8
#define CONS_NON_SKIP_RATE 2
#define INITIAL_RATING 100
#define THRESHOLD_GROW 0.3
#define THRESHOLD_DECAY 0.1
#define EXPONENT_STEP 5
#define BIAS 1

#define TERM_WIDTH 80

using namespace std;

static const int xmms_session = 0;

class Imms
{
    public:
        Imms();
        bool song_changed(const string &path, int time_left, bool jumped);
        void setup(const char* _email, const char* _logfile);

    protected:
        void set_popm(int mod);
        inline int get_popm();

        ofstream fout;

        string email;
        double threshold;
        bool last_skipped, last_jumped, dont_rate;

        ID3_Tag id3tag;
};

#endif
